package com.cheesemoon.android_flight_controller;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.graphics.PorterDuff;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;

public class Controller_Pad extends SurfaceView implements SurfaceHolder.Callback {
    //  畫布
    private SurfaceHolder sfh;

    public int getSurfaceView_Width() {
        return SurfaceView_Width;
    }

    // SurfaceView 寬.高
    private int SurfaceView_Width;

    public int getSurfaceView_Height() {
        return SurfaceView_Height;
    }

    private int SurfaceView_Height;

    private float touch_X = 0;
    private float touch_Y = 0;

    public float getTouch_X() {
        return touch_X;
    }

    public float getTouch_Y() {
        return touch_Y;
    }

    public float getMovie_Value_X() {
        return center_X + Movie_Value_X;
    }

    public float getMovie_Value_Y() {
        if (!Y_Axis_Canter) {
            return -(Movie_Value_Y + Movie_Value_Y_no_Canter);
        } else
            return SurfaceView_Height - (center_Y + Movie_Value_Y);
    }

    private float center_X = 0;
    private float center_Y = 0;

    private boolean ACTION_DOWN = false;

    private boolean Y_Axis_Canter = true;

    public void setY_Axis_canter(boolean y_axis_canter) {
        Y_Axis_Canter = y_axis_canter;
    }

    private float Movie_Value_X = 0;
    private float Movie_Value_Y = 0;
    private float Movie_Value_Y_no_Canter = 0;

    public Controller_Pad(Context context, AttributeSet attrs) {
        super(context, attrs);
        Surface_View_Init();
    }

    private void Surface_View_Init() {
        sfh = this.getHolder();
        sfh.addCallback(this);
        this.setZOrderOnTop(true);
        this.getHolder().setFormat(PixelFormat.TRANSLUCENT);
    }

    @Override
    public void surfaceCreated(SurfaceHolder surfaceHolder) {
        SurfaceView_Width = this.getMeasuredWidth();
        SurfaceView_Height = this.getMeasuredHeight();
        center_X = touch_X = SurfaceView_Width / 2;
        center_Y = touch_Y = SurfaceView_Height / 2;
        if (!Y_Axis_Canter) {
            touch_Y = SurfaceView_Height;
        }
        draw();
        this.setOnTouchListener(SurfaceView_Touch_Event);
    }

    @Override
    public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {

    }

    @Override
    public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

    }

    public void draw() {
        try {
            // 繪圖準備
            Canvas canvas = sfh.lockCanvas(new Rect(0, 0, SurfaceView_Width, SurfaceView_Height));
            Paint paint = new Paint();
            Rect rect;
            canvas.drawColor(Color.TRANSPARENT, PorterDuff.Mode.CLEAR);
            // 繪圖準備
            paint.setARGB(100, 65, 250, 222);
            paint.setAntiAlias(true);
            paint.setStrokeCap(Paint.Cap.BUTT);
            paint.setStyle(Paint.Style.STROKE);

            float X = 0, Y = 0;
//            if (Y_Axis_Canter) {
            if (!ACTION_DOWN) {
                X = center_X;
                Y = center_Y;
                if (!Y_Axis_Canter) {
                    Y = touch_Y;
                }
            } else {
                X = touch_X + Movie_Value_X;
                Y = touch_Y + Movie_Value_Y;
            }
            canvas.drawCircle(X, Y, 100, paint);
            canvas.drawCircle(X, Y, 99, paint);
            canvas.drawCircle(X, Y, 98, paint);
            canvas.drawCircle(X, Y, 97, paint);
            canvas.drawCircle(X, Y, 96, paint);
            canvas.drawCircle(X, Y, 95, paint);
            canvas.drawCircle(X, Y, 94, paint);
            canvas.drawCircle(X, Y, 93, paint);
            canvas.drawCircle(X, Y, 92, paint);
            canvas.drawCircle(X, Y, 91, paint);
            canvas.drawCircle(X, Y, 90, paint);

            // 呈現至螢幕
            sfh.unlockCanvasAndPost(canvas);
        } catch (Exception ignored) {
        }
    }

    private OnTouchListener SurfaceView_Touch_Event = new OnTouchListener() {
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            try {
                int index;          //取得多點觸控的 index
                switch (motionEvent.getAction() & MotionEvent.ACTION_MASK) {
                    case MotionEvent.ACTION_DOWN:
                    case MotionEvent.ACTION_POINTER_DOWN:
                        ACTION_DOWN = true;
                        index = motionEvent.getActionIndex();
                        touch_X = motionEvent.getX(index);
                        touch_Y = motionEvent.getY(index);
                        break;
                    case MotionEvent.ACTION_MOVE:
                        int pointCount = motionEvent.getPointerCount();
                        for (int i = 0; i < pointCount; i++) {
                            Movie_Value_X = motionEvent.getX(i) - touch_X;
                            Movie_Value_Y = motionEvent.getY(i) - touch_Y;
                            Log.i("test_y", "touch_Y = " + touch_Y + " now = " + motionEvent.getY(i) + " Movie_Value_Y = " + Movie_Value_Y);
                        }
                        break;
                    case MotionEvent.ACTION_UP:
                    case MotionEvent.ACTION_POINTER_UP:
                        ACTION_DOWN = false;
                        index = motionEvent.getActionIndex();
                        Movie_Value_X = 0;
                        if(!Y_Axis_Canter) {
                            Movie_Value_Y_no_Canter += Movie_Value_Y;
                            Movie_Value_Y_no_Canter = (-Movie_Value_Y_no_Canter >= SurfaceView_Height) ? -SurfaceView_Height : Movie_Value_Y_no_Canter;
                            Movie_Value_Y_no_Canter = (-Movie_Value_Y_no_Canter <= 0) ? 0 : Movie_Value_Y_no_Canter;
                            Log.i("Test_tmp", "SurfaceView_Height = " + SurfaceView_Height + " Movie_Value_Y = " + Movie_Value_Y + " Movie_Value_Y_no_Canter = " + Movie_Value_Y_no_Canter);
                        }
                        Movie_Value_Y = 0;
                        touch_X = center_X;
                        touch_Y = center_Y;
                        if (!Y_Axis_Canter)
                            touch_Y = motionEvent.getY(index);
                        break;
                    default:
                        break;
                }
            } catch (Exception ignored) {

            }
            draw();
            return true;
        }
    };


}
