package com.cheesemoon.android_flight_controller;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.KeyEvent;
import android.view.WindowManager;
import android.widget.ToggleButton;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.List;

public class Flight_Controller extends AppCompatActivity {

    Controller_Pad ctr_pad_left;
    Controller_Pad ctr_pad_right;

    private int Left_X;
    private int Left_Y;
    private int Right_X;
    private int Right_Y;

    private HandlerThread mThread;
    private Handler mThreadHandler;
    private Boolean Connect_status = false;
    private String SERVER_IP_Send_Command = "192.168.18.76";
    private int SERVER_PORT_Send_Command = 6667;

    private int Controller_Mode = 1;
    private final int Japan_List = 1;

    private static Save_and_Read_Database SARD;

    List<ToggleButton> toggleButtons = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        setContentView(R.layout.fight_controller);

        init();

        Connect_status = true;
        mThread = new HandlerThread("name");
        mThread.start();
        mThreadHandler = new Handler(mThread.getLooper());
        mThreadHandler.post(send_Command);
    }

    void init() {
        ctr_pad_left = findViewById(R.id.ctr_pad_left);
        ctr_pad_right = findViewById(R.id.ctr_pad_right);
        SARD = new Save_and_Read_Database();
        SARD.settings = getSharedPreferences("DATA", 0);
        SERVER_IP_Send_Command = SARD.read_IP();
        SERVER_PORT_Send_Command = SARD.read_PORT();
        if (SARD.read_Control_Type() == new Option_data().JAPAN_Mode) {
            ctr_pad_right.setY_Axis_canter(false);
        } else if (SARD.read_Control_Type() == new Option_data().inverter_JAPAN_Mode) {
            ctr_pad_left.setY_Axis_canter(false);
        }
        if (SARD.read_Control_Type() == new Option_data().USA_Mode) {
            ctr_pad_left.setY_Axis_canter(false);
        }
        if (SARD.read_Control_Type() == new Option_data().inverter_USA_Mode) {
            ctr_pad_right.setY_Axis_canter(false);
        }

        toggleButtons.add(findViewById(R.id.ToggleButton1));
        toggleButtons.add(findViewById(R.id.ToggleButton2));
        toggleButtons.add(findViewById(R.id.ToggleButton3));
        toggleButtons.add(findViewById(R.id.ToggleButton4));
        toggleButtons.add(findViewById(R.id.ToggleButton5));
        toggleButtons.add(findViewById(R.id.ToggleButton6));
        toggleButtons.add(findViewById(R.id.ToggleButton7));
        toggleButtons.add(findViewById(R.id.ToggleButton8));
        for (ToggleButton tb : toggleButtons) {
            int id = toggleButtons.indexOf(tb) + 1;
            tb.setText(SARD.read_Switch_Name(id));
            tb.setTextOff(SARD.read_Switch_Name(id));
            tb.setTextOn(SARD.read_Switch_Name(id));
            Log.i("ToggleButton_test", "id = " + id);
        }
    }

    private Runnable send_Command = new Runnable() {
        public void run() {
            try {
                InetAddress serverAddr;
                DatagramSocket socket;
                DatagramPacket packet;
                while (Connect_status) {
                    Left_X = (int) ctr_pad_left.getMovie_Value_X();
                    Left_X = to_SBUS_Step_1(Left_X, ctr_pad_left.getSurfaceView_Width());
                    Left_Y = (int) ctr_pad_left.getMovie_Value_Y();
                    Left_Y = to_SBUS_Step_1(Left_Y, ctr_pad_left.getSurfaceView_Height());
                    Right_X = (int) ctr_pad_right.getMovie_Value_X();
                    Right_X = to_SBUS_Step_1(Right_X, ctr_pad_right.getSurfaceView_Width());
                    Right_Y = (int) ctr_pad_right.getMovie_Value_Y();
                    Right_Y = to_SBUS_Step_1(Right_Y, ctr_pad_right.getSurfaceView_Height());
                    Log.i("touch_test", "Left_X = " + Left_X + " Left_Y = " + Left_Y + " Right_X = " + Right_X + " Right_Y = " + Right_Y);

                    int[] channel = new int[16];
                    for (int i = 0; i < channel.length; i++) {
                        channel[i] = to_SBUS_Step_1(0, ctr_pad_left.getSurfaceView_Height());
                    }

                    if (SARD.read_Control_Type() == new Option_data().JAPAN_Mode) {
                        channel[0] = Right_X;
                        channel[1] = Left_Y;
                        channel[2] = Right_Y;
                        channel[3] = Left_X;
                    } else if (SARD.read_Control_Type() == new Option_data().inverter_JAPAN_Mode) {
                        channel[0] = Left_X;
                        channel[1] = Right_Y;
                        channel[2] = Left_Y;
                        channel[3] = Right_X;
                    }
                    if (SARD.read_Control_Type() == new Option_data().USA_Mode) {
                        channel[0] = Right_X;
                        channel[1] = Right_Y;
                        channel[2] = Left_Y;
                        channel[3] = Left_X;
                    }
                    if (SARD.read_Control_Type() == new Option_data().inverter_USA_Mode) {
                        channel[0] = Left_X;
                        channel[1] = Left_Y;
                        channel[2] = Right_Y;
                        channel[3] = Right_X;
                    }
                    for (ToggleButton tb : toggleButtons) {
                        int id = toggleButtons.indexOf(tb) + 1;
                        int Switch_Channel = SARD.read_Switch_Channel(id);
                        int Value = 0;
                        if (!tb.isChecked()) {
                            Value = SARD.read_Switch_Value_Min(id);
                        } else if (tb.isChecked()) {
                            Value = SARD.read_Switch_Value_Max(id);
                        }
                        if (Switch_Channel != 0) {
                            Value = to_SBUS_Step_1(Value, 1200);
                            channel[Switch_Channel + 3] = Value;
                        }
                    }

                    byte[] flight_command = new byte[32];
                    int[] tmp_123 = new int[32];
                    for (int i = 0; i < 16; i++) {
                        byte[] tmp = Math_Convernt.int_to_byteArray(channel[i]);
                        flight_command[i * 2] = tmp[0];
                        flight_command[i * 2 + 1] = tmp[1];

                        tmp_123[i * 2] = tmp[0] & 0xFF;
                        tmp_123[i * 2 + 1] = tmp[1] & 0xFF;
                    }

                    serverAddr = InetAddress.getByName(SERVER_IP_Send_Command);
                    socket = new DatagramSocket();
                    packet = new DatagramPacket(flight_command, flight_command.length, serverAddr, SERVER_PORT_Send_Command);
                    socket.send(packet);
                    socket.close();

                    Thread.sleep(10);
                }
                if (!Connect_status) {
                    try {
                        int[] channel = new int[16];
                        for (int i = 0; i < channel.length; i++) {
                            channel[i] = to_SBUS_Step_1(0, ctr_pad_left.getSurfaceView_Height());
                        }

                        channel[0] = to_SBUS_Step_1(ctr_pad_left.getSurfaceView_Height() / 2, ctr_pad_left.getSurfaceView_Height());
                        channel[1] = to_SBUS_Step_1(ctr_pad_left.getSurfaceView_Height() / 2, ctr_pad_left.getSurfaceView_Height());
                        channel[2] = to_SBUS_Step_1(0, ctr_pad_left.getSurfaceView_Height());
                        channel[3] = to_SBUS_Step_1(ctr_pad_left.getSurfaceView_Height() / 2, ctr_pad_left.getSurfaceView_Height());
                        channel[5] = to_SBUS_Step_1(0, ctr_pad_left.getSurfaceView_Height());
                        channel[6] = to_SBUS_Step_1(0, ctr_pad_left.getSurfaceView_Height());

                        byte[] flight_command = new byte[32];
                        for (int i = 0; i < 16; i++) {
                            byte[] tmp = Math_Convernt.int_to_byteArray(channel[i]);
                            flight_command[i * 2] = tmp[0];
                            flight_command[i * 2 + 1] = tmp[1];
                        }

                        serverAddr = InetAddress.getByName(SERVER_IP_Send_Command);
                        socket = new DatagramSocket();
                        packet = new DatagramPacket(flight_command, flight_command.length, serverAddr, SERVER_PORT_Send_Command);
                        socket.send(packet);
                        socket.close();

                        Thread.sleep(100);
                    } catch (Exception ignored) {
                        Log.e("ERROR_Test", "" + ignored.toString());
                    }
                }
            } catch (Exception ignored) {
                Log.e("ERROR_Test", "" + ignored.toString());
            }
        }
    };

    private int to_SBUS_Step_1(int input, int size) {
//          # SBUS 輸出992 飛控接收會轉為1500
//          # 992 - 960 = 32    飛控接收會轉為900
//          # 992 + 960 = 1952  飛控接收會轉為2100
//          # 32  ---- 992  ---- 1952       SBUS send
//          # 900 ---- 1500 ---- 2100       SBUS receive
        input = (input > size) ? size : input;
        input = (input < 0) ? 0 : input;
        int map_min = 32;
        int map_max = 1952;
        int tmp = map_max - map_min;
        int output = (int) ((float) input * ((float) tmp / (float) size));
        output += map_min;
        return output;
    }

    private int to_SBUS_Step_2(int input) {
//          # SBUS 輸出992 飛控接收會轉為1500
//          # 992 - 960 = 32    飛控接收會轉為900
//          # 992 + 960 = 1952  飛控接收會轉為2100
//          # 32  ---- 992  ---- 1952       SBUS send
//          # 900 ---- 1500 ---- 2100       SBUS receive
        int map_min = 900;
        int map_max = 2100;
        int tmp = map_max - map_min;
        int output = (int) ((float) input * ((float) tmp / (float) 1952));
        output += map_min;
        return output;
    }

    /**
     * 攔截手機實體按鍵的事件
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {     // 攔截 BACK 鍵
            Connect_status = false;
            Intent intent = new Intent(Flight_Controller.this, Wellcom.class);
            startActivity(intent);
            this.finish();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
}
