package com.cheesemoon.android_flight_controller;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class Option_Page extends AppCompatActivity {

    EditText EditText_IP;
    EditText EditText_PORT;
    Button Button_Submit;
    Spinner Spinner_Controller_Type;
    int Controller_Type = 0;
    // 資料儲存模組
    private static Save_and_Read_Database SARD;

    @SuppressLint("SetTextI18n")
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        setContentView(R.layout.option_page);

        SARD = new Save_and_Read_Database();
        SARD.settings = getSharedPreferences("DATA", 0);

        EditText_IP = findViewById(R.id.EditText_IP);
        EditText_IP.setText(SARD.read_IP());
        EditText_PORT = findViewById(R.id.EditText_PORT);
        EditText_PORT.setText("" + SARD.read_PORT());
        Button_Submit = findViewById(R.id.Button_Submit);

        Spinner_Controller_Type = findViewById(R.id.Spinner_Controller_Type);
        ArrayAdapter<CharSequence> Controller_Type_List = ArrayAdapter.createFromResource(Option_Page.this,
                R.array.Controller_Type, android.R.layout.simple_spinner_dropdown_item);
        Spinner_Controller_Type.setAdapter(Controller_Type_List);
        Spinner_Controller_Type.setSelection(SARD.read_Control_Type() - 1);
        Spinner_Controller_Type.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                Controller_Type = i + 1;
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        Button_Submit.setOnClickListener(view -> {
            SARD.save_IP(EditText_IP.getText().toString());
            SARD.save_PORT(Integer.parseInt(EditText_PORT.getText().toString()));
            SARD.save_Control_Type(Controller_Type);
            Log.i("SARD", "IP = " + SARD.read_IP() + " PORT = " + SARD.read_PORT() + " Type = " + SARD.read_Control_Type());
            Intent intent = new Intent(Option_Page.this, Wellcom.class);
            startActivity(intent);
            finish();
        });
    }

    /**
     * 攔截手機實體按鍵的事件
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {     // 攔截 BACK 鍵
            Intent intent = new Intent(Option_Page.this, Wellcom.class);
            startActivity(intent);
            this.finish();
//            System.exit(0);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
}
