package com.cheesemoon.android_flight_controller;

import android.content.Intent;
import android.os.Bundle;
import android.renderscript.Sampler;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.ToggleButton;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by CheeseMoon_ on 2018/5/21.
 */

public class Switch_Setting extends AppCompatActivity {
    Save_and_Read_Database SARD;

    List<Button> buttons = new ArrayList<>();

    Button Button_Save;
    Button Button_Out;

    EditText EditText_Switch_Name;
    Spinner Spinner_Switch_Channel_Number;
    SeekBar SeekBar_Switch_Min_Value;
    TextView text_Min_Value;
    SeekBar SeekBar_Switch_Max_Value;
    TextView text_Max_Value;

    String Switch_Name = "";
    int Switch_Channel = 0;
    int Value_Min = 0;
    int Value_Max = 0;
    int id = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        setContentView(R.layout.switch_setting);

        SARD = new Save_and_Read_Database();
        SARD.settings = getSharedPreferences("DATA", 0);

        id = 1;
        Switch_Name = SARD.read_Switch_Name(id);
        Switch_Channel = SARD.read_Switch_Channel(id);
        Value_Min = SARD.read_Switch_Value_Min(id);
        Value_Max = SARD.read_Switch_Value_Max(id);

        findViewById();
        set_event();

        update_information(id);
    }


    void findViewById() {
        buttons.add(findViewById(R.id.button1));
        buttons.add(findViewById(R.id.button2));
        buttons.add(findViewById(R.id.button3));
        buttons.add(findViewById(R.id.button4));
        buttons.add(findViewById(R.id.button5));
        buttons.add(findViewById(R.id.button6));
        buttons.add(findViewById(R.id.button7));
        buttons.add(findViewById(R.id.button8));

        EditText_Switch_Name = findViewById(R.id.EditText_Switch_Name);
        Spinner_Switch_Channel_Number = findViewById(R.id.Spinner_Switch_Channel_Number);
        SeekBar_Switch_Min_Value = findViewById(R.id.SeekBar_Switch_Min_Value);
        SeekBar_Switch_Max_Value = findViewById(R.id.SeekBar_Switch_Max_Value);

        text_Min_Value = findViewById(R.id.text_Min_Value);
        text_Max_Value = findViewById(R.id.text_Max_Value);

        Button_Save = findViewById(R.id.Button_Save);
        Button_Out = findViewById(R.id.Button_Out);
    }

    void set_event() {

        text_Min_Value.setText("" + (Value_Min + 900));
        text_Max_Value.setText("" + (Value_Max + 900));

        for (Button b : buttons) {
            int id = buttons.indexOf(b) + 1;
            b.setText(SARD.read_Switch_Name(id));
            b.setOnClickListener(button_event);
        }
        Button_Save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (!EditText_Switch_Name.getText().toString().equals("")) {
                    SARD.save_Switch_Name(id, EditText_Switch_Name.getText().toString());
                    buttons.get(id - 1).setText(EditText_Switch_Name.getText().toString());
                } else {
                    SARD.save_Switch_Name(id, "功能" + id);
                    buttons.get(id - 1).setText("功能" + id);
                }
                SARD.save_Switch_Channel(id, Switch_Channel);
                SARD.save_Switch_Value_Min(id, Value_Min);
                SARD.save_Switch_Value_Max(id, Value_Max);
            }
        });
        Button_Out.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Switch_Setting.this, Wellcom.class);
                startActivity(intent);
                finish();
            }
        });

        ArrayAdapter<CharSequence> Channel_Name_List = ArrayAdapter.createFromResource(Switch_Setting.this,
                R.array.Channel_Name, android.R.layout.simple_spinner_dropdown_item);
        Spinner_Switch_Channel_Number.setAdapter(Channel_Name_List);
        Spinner_Switch_Channel_Number.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                Switch_Channel = i;
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        SeekBar_Switch_Min_Value.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int i, boolean b) {
                Value_Min = i;
                text_Min_Value.setText("" + (Value_Min + 900));
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        SeekBar_Switch_Max_Value.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int i, boolean b) {
                Value_Max = i;
                text_Max_Value.setText("" + (Value_Max + 900));
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

    }

    View.OnClickListener button_event = new View.OnClickListener() {
        @Override
        public void onClick(View view) {
            id = buttons.indexOf(view) + 1;
            Log.i("getId", "" + id);
            update_information(id);
        }
    };

    void update_information(int id) {
        Switch_Name = SARD.read_Switch_Name(id);
        Switch_Channel = SARD.read_Switch_Channel(id);
        Value_Min = SARD.read_Switch_Value_Min(id);
        Value_Max = SARD.read_Switch_Value_Max(id);

        EditText_Switch_Name.setText(Switch_Name);
        Spinner_Switch_Channel_Number.setSelection(Switch_Channel);
        SeekBar_Switch_Min_Value.setProgress(Value_Min);
        SeekBar_Switch_Max_Value.setProgress(Value_Max);
    }

    /**
     * 攔截手機實體按鍵的事件
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {     // 攔截 BACK 鍵
            Intent intent = new Intent(Switch_Setting.this, Wellcom.class);
            startActivity(intent);
            this.finish();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
}
